def is_safe(report: list[int]) -> bool:
global removed
acceptable_range = [_ for _ in range(-3,4) if _ != 0]
diffs = []
if any([report.count(x) > 2 for x in report]):
return False
for i, num in enumerate(report[:-1]):
cur = num
next = report[i+1]
difference = cur - next
diffs.append(difference)
if difference not in acceptable_range:
return False
if len(diffs) > 1:
if diffs[-1] * diffs[-2] <= 0:
return False
return True
with open('input') as reports:
list_of_reports = reports.readlines()[:-1]
count = 0
failed_first_pass = []
failed_twice = []
for reportsub in list_of_reports:
levels = [int(l) for l in reportsub.split()]
original = levels.copy()
if is_safe(levels):
safe = True
count += 1
else:
failed_first_pass.append(levels)
for report in failed_first_pass:
print(report)
working_copy = report.copy()
for i in range(len(report)):
safe = False
working_copy.pop(i)
print("checking", working_copy)
if is_safe(working_copy):
count += 1
safe = True
break
else:
working_copy = report.copy()
print(count)
Advent Of Code
An unofficial home for the advent of code community on programming.dev!
Advent of Code is an annual Advent calendar of small programming puzzles for a variety of skill sets and skill levels that can be solved in any programming language you like.
AoC 2024
Solution Threads
M | T | W | T | F | S | S |
---|---|---|---|---|---|---|
1 | ||||||
2 | 3 | 4 | 5 | 6 | 7 | 8 |
9 | 10 | 11 | 12 | 13 | 14 | 15 |
16 | 17 | 18 | 19 | 20 | 21 | 22 |
23 | 24 | 25 |
Rules/Guidelines
- Follow the programming.dev instance rules
- Keep all content related to advent of code in some way
- If what youre posting relates to a day, put in brackets the year and then day number in front of the post title (e.g. [2024 Day 10])
- When an event is running, keep solutions in the solution megathread to avoid the community getting spammed with posts
Relevant Communities
Relevant Links
Credits
Icon base by Lorc under CC BY 3.0 with modifications to add a gradient
console.log('Hello World')
Factor
: get-input ( -- reports )
"aoc-2024.02" "input.txt" vocab-file-lines
[ split-words [ string>number ] map ] map ;
: slanted? ( report -- ? )
{ [ [ > ] monotonic? ] [ [ < ] monotonic? ] } || ;
: gradual? ( report -- ? )
[ - abs 1 3 between? ] monotonic? ;
: safe? ( report -- ? )
{ [ slanted? ] [ gradual? ] } && ;
: part1 ( -- n )
get-input [ safe? ] count ;
: fuzzy-reports ( report -- reports )
dup length <iota> [ remove-nth-of ] with map ;
: tolerable? ( report -- ? )
{ [ safe? ] [ fuzzy-reports [ safe? ] any? ] } || ;
: part2 ( -- n )
get-input [ tolerable? ] count ;
Quite the interesting language choice. It's so clean. I love it!
Lisp
Part 1
(defun p1-process-line (line)
(mapcar #'parse-integer (str:words line)))
(defun line-direction-p (line)
"make sure the line always goes in the same direction"
(loop for x in line
for y in (cdr line)
count (> x y) into dec
count (< x y) into inc
when (and (> dec 0 ) (> inc 0)) return nil
when (= x y) return nil
finally (return t)))
(defun line-in-range-p (line)
"makes sure the delta is within 3"
(loop for x in line
for y in (cdr line)
for delta = (abs (- x y))
when (or (> delta 3) )
return nil
finally (return t)))
(defun test-line-p (line)
(and (line-in-range-p line) (line-direction-p line)))
(defun run-p1 (file)
(let ((data (read-file file #'p1-process-line)))
(apply #'+ (mapcar (lambda (line) (if (test-line-p line) 1 0)) data))))
Part 2
(defun test-line-p2 (line)
(or (test-line-p (cdr line))
(test-line-p (cdr (reverse line)))
(loop for back on line
collect (car back) into front
when (test-line-p (concatenate 'list front (cddr back)))
return t
finally (return nil)
)))
(defun run-p2 (file)
(let ((data (read-file file #'p1-process-line)))
(loop for line in data
count (test-line-p2 line))))
Rust
Turned out alright, I am looking forward to seeing what 2d coordinate grid code I can cannibalize from last year's solutions π
I think that repo is private
I realized after I posted π thanks for pointing it out! I will go make it public
JavaScript
Also wrote a solution in JavaScript to play around with list comprehension. Wrote some utility functions for expressiveness (and lazy evaluation).
Code
const fs = require("fs");
const U = require("./util");
const isSafe = xs =>
U.pairwise(xs).every(([a,b]) => a!==b && a-b > -4 && a-b < 4) &&
new Set(U.pairwise(xs).map(([a,b]) => a < b)).size === 1;
const rows = fs
.readFileSync(process.argv[2] || process.stdin.fd, "utf8")
.split("\n")
.filter(x => x != "")
.map(x => x.split(/ +/).map(Number));
const p1 = U.countBy(rows, isSafe);
const p2 = U.countBy(rows, row =>
isSafe(row) || U.someBy(U.indices(row),
i => isSafe([...row.slice(0, i), ...row.slice(i+1)])));
console.log("02:", p1, p2);
https://github.com/sjmulder/aoc/blob/master/2024/js/day02.js
G'MIC solution
spoiler
it day2
crop. 0,0,0,{h#-1-2}
split. -,{_'\n'}
foreach { replace_str. " ",";" ({t}) rm.. }
safe_0,safe_1=0
foreach {
({h}) a[-2,-1] y
num_of_attempts:=da_size(#-1)+1
store temp
repeat $num_of_attempts {
$temp
if $> eval da_remove(#-1,$>-1) fi
eval "
safe=1;
i[#-1,1]>i[#-1,0]?(
for(p=1,p<da_size(#-1),++p,
if(!inrange(i[#-1,p]-i[#-1,p-1],1,3,1,1),safe=0;break(););
);
):(
for(p=1,p<da_size(#-1),++p,
if(!inrange(i[#-1,p-1]-i[#-1,p],1,3,1,1),safe=0;break(););
);
);
safe;"
rm
if $>
if ${} safe_1+=1 break fi
else
if ${} safe_0,safe_1+=1 break fi
fi
}
}
echo Day" "2:" "${safe_0}" :: "${safe_1}
This is my very naive rust solution, part 2 is mostly just an extra function, so theyβre bother covered in this one.
#Rust
initially, for part two I was trying to ignore a bad pair not a bad value - read the question!
Only installed Rust on Sunday, day 1 was a mess, today was more controlled. Need to look at some of the rust solutions for std library methods I don't know about.
very focussed on getting it to actually compile/work over making it short or nice!
long!
`
pub mod task_2 {
pub fn task_1(input: &str) -> i32{
let mut valid_count = 0;
let reports = process_input(input);
for report in reports{
let valid = is_report_valid(report);
if valid{
valid_count += 1;
}
}
println!("Valid count: {}", valid_count);
valid_count
}
pub fn task_2(input: &str) -> i32{
let mut valid_count = 0;
let reports = process_input(input);
for report in reports{
let mut valid = is_report_valid(report.clone());
if !valid
{
for position_to_delete in 0..report.len()
{
let mut updated_report = report.clone();
updated_report.remove(position_to_delete);
valid = is_report_valid(updated_report);
if valid { break; }
}
}
if valid{
valid_count += 1;
}
}
println!("Valid count: {}", valid_count);
valid_count
}
fn is_report_valid(report:Vec<i32>) -> bool{
let mut increasing = false;
let mut decreasing = false;
let mut valid = true;
for position in 1..report.len(){
if report[position-1] > report[position]
{
decreasing = true;
}
else if report[position-1] < report[position]
{
increasing = true;
}
else
{
valid = false;
break;
}
if (report[position-1] - report[position]).abs() > 3
{
valid = false;
break;
}
if increasing && decreasing
{
valid = false;
break;
}
}
return valid;
}
pub fn process_input(input: &str) -> Vec<Vec<i32>>{
let mut reports: Vec<Vec<i32>> = Vec::new();
for report_string in input.split("\n"){
let mut report: Vec<i32> = Vec::new();
for value in report_string.split_whitespace() {
report.push(value.parse::<i32>().unwrap());
}
reports.push(report);
}
return reports;
}
}
`
Nim
import strutils, times, sequtils, sugar
# check if level transition in record is safe
proc isSafe*(sign:bool, d:int): bool =
sign == (d>0) and d.abs in 1..3;
#check if record is valid
proc validate*(record:seq[int]): bool =
let sign = record[0] > record[1];
return (0..record.len-2).allIt(isSafe(sign, record[it] - record[it+1]))
# check if record is valid as-is
# or if removing any item makes the record valid
proc validate2*(record:seq[int]): bool =
return record.validate or (0..<record.len).anyIt(record.dup(delete(it)).validate)
proc solve*(input:string): array[2,int] =
let lines = input.readFile.strip.splitLines;
let records = lines.mapIt(it.splitWhitespace.map(parseInt));
result[0] = records.countIt(it.validate);
result[1] = records.countIt(it.validate2);
I got stuck on part 2 trying to check everything inside a single loop, which kept getting more ugly. So then I switched to just deleting one item at a time and re-checking the record.
Reworked it after first finding the solution to compress the code a bit, though the range iterators don't really help with readability.
I did learn about the sugar
import, which I used to make the sequence duplication more compact: record.dup(delete(it)
.
Cool to see another solution in Nim here =)
(0..<record.len).anyIt(record.dup(delete(it)).validate)
That's smart. I haven't thought of using iterators to loop over indexes (except in a for loop
).
I got stuck on part 2 trying to check everything inside a single loop, which kept getting more ugly.
Yeah I've thought of simple ways to do this and found none. And looking at the input - it's too easy to bruteforce, especially in compiled lang like Nim.
Haskell
Had some fun with arrows.
import Control.Arrow
import Control.Monad
main = getContents >>= print . (part1 &&& part2) . fmap (fmap read . words) . lines
part1 = length . filter isSafe
part2 = length . filter (any isSafe . removeOne)
isSafe = ap (zipWith (-)) tail >>> (all (between 1 3) &&& all (between (-3) (-1))) >>> uncurry (||)
where
between a b = (a <=) &&& (<= b) >>> uncurry (&&)
removeOne [] = []
removeOne (x : xs) = xs : fmap (x :) (removeOne xs)
TypeScript
Solution
import { AdventOfCodeSolutionFunction } from "./solutions";
/**
* this function evaluates the
* @param levels a list to check
* @returns -1 if there is no errors, or the index of where there's an unsafe event
*/
export function EvaluateLineSafe(levels: Array<number>) {
// this loop is the checking every number in the line
let isIncreasing: boolean | null = null;
for (let levelIndex = 1; levelIndex < levels.length; levelIndex++) {
const prevLevel = levels[levelIndex - 1]; // previous
const level = levels[levelIndex]; // current
const diff = level - prevLevel; // difference
const absDiff = Math.abs(diff); // absolute difference
// check if increasing too much or not at all
if (absDiff == 0 || absDiff > 3)
return levelIndex; // go to the next report
// set increasing if needed
if (isIncreasing === null) {
isIncreasing = diff > 0;
continue; // compare the next numbers
}
// check if increasing then decreasing
if (!(isIncreasing && diff > 0 || !isIncreasing && diff < 0))
return levelIndex; // go to the next report
}
return -1;
}
export const solution_2: AdventOfCodeSolutionFunction = (input) => {
const reports = input.split("\n");
let safe = 0;
let safe_damp = 0;
// this loop is for every line
main: for (let i = 0; i < reports.length; i++) {
const report = reports[i].trim();
if (!report)
continue; // report is empty
const levels = report.split(" ").map((v) => Number(v));
const evaluation = EvaluateLineSafe(levels);
if(evaluation == -1) {
safe++;
continue;
}
// search around where it failed
for (let offset = evaluation - 2; offset <= evaluation + 2; offset++) {
// delete an evaluation in accordance to the offset
let newLevels = [...levels];
newLevels.splice(offset, 1);
const newEval = EvaluateLineSafe(newLevels);
if(newEval == -1) {
safe_damp++;
continue main;
}
}
}
return `Part 1: ${safe} Part 2: ${safe + safe_damp}`;
}
God, I really wish my solutions weren't so convoluted. Also, this is an O(N^3) solution....
I don't think your solution is O(N^3). Can you explain your reasoning?
3 nested for loops
It's not as simple as that. You can have 20 nested for loops with complexity of O(1) if all of them only ever finish one iteration.
Or you can have one for loop that iterates 2^N times.
What do you think my complexity is?
I think it could be maybe O(n^2) because the other for loop which tries elements around the first error will only execute a constant of 5 times in the worst case? I'm unsure.
It really depends on what your parameter n is. If the only relevant size is the number of records (let's say that is n), then this solution takes time in O(n), because it loops over records only once at a time. This ignores the length of records by considering it constant.
If we also consider the maximum length of records (let's call it m), then your solution, and most others I've seen in this thread, has a time complexity in O(n * m^2) for part 2.
It's O(n).
If you look at each of the levels of all reports, you will access it a constant number of times: at most twice in each call to EvaluateLineSafe
, and you will call EvaluateLineSafe
at most six times for each report.
Rust
use crate::utils::read_lines;
pub fn solution1() {
let reports = get_reports();
let safe_reports = reports
.filter(|report| report.windows(3).all(window_is_valid))
.count();
println!("Number of safe reports = {safe_reports}");
}
pub fn solution2() {
let reports = get_reports();
let safe_reports = reports
.filter(|report| {
(0..report.len()).any(|i| {
[&report[0..i], &report[i + 1..]]
.concat()
.windows(3)
.all(window_is_valid)
})
})
.count();
println!("Number of safe reports = {safe_reports}");
}
fn window_is_valid(window: &[usize]) -> bool {
matches!(window[0].abs_diff(window[1]), 1..=3)
&& matches!(window[1].abs_diff(window[2]), 1..=3)
&& ((window[0] > window[1] && window[1] > window[2])
|| (window[0] < window[1] && window[1] < window[2]))
}
fn get_reports() -> impl Iterator<Item = Vec<usize>> {
read_lines("src/day2/input.txt").map(|line| {
line.split_ascii_whitespace()
.map(|level| {
level
.parse()
.expect("Reactor level is always valid integer")
})
.collect()
})
}
Definitely trickier than yesterday's. I feel like the windows
solution isn't the best, but it was what came to mind and ended up working for me.
I forgot that this started yesterday, so I'm already behind. I quite like my solution for part one, but part two will have to wait.
Rust
use color_eyre::eyre;
use std::{fs, num, str::FromStr};
#[derive(Debug, PartialEq, Eq)]
struct Report(Vec<isize>);
impl FromStr for Report {
type Err = num::ParseIntError;
fn from_str(s: &str) -> Result<Self, Self::Err> {
let v: Result<Vec<isize>, _> = s
.split_whitespace()
.map(|num| num.parse::<isize>())
.collect();
Ok(Report(v?))
}
}
impl Report {
fn is_safe(&self) -> bool {
let ascending = self.0[1] > self.0[0];
let (low, high) = if ascending { (1, 3) } else { (-3, -1) };
self.0.windows(2).all(|w| {
let a = w[0];
let b = w[1];
b >= a + low && b <= a + high
})
}
}
fn main() -> eyre::Result<()> {
color_eyre::install()?;
let part1 = part1("d02/input.txt")?;
println!("Part 1: {part1}");
Ok(())
}
fn part1(filepath: &str) -> eyre::Result<isize> {
let mut num_safe = 0;
for l in fs::read_to_string(filepath)?.lines() {
if Report::from_str(l)?.is_safe() {
num_safe += 1;
}
}
Ok(num_safe)
}
#[cfg(test)]
mod tests {
use super::*;
#[test]
fn sample_part1() {
assert_eq!(part1("test.txt").unwrap(), 2);
}
}
J
There is probably a way to write this more point-free. You can definitely see here the friction involved in the way J wants to regard lists as arrays: short rows of the input matrix are zero padded, so you have to snip off the padding before you process each row, and that means you can't lift some of the operations back up to the parent matrix because it will re-introduce the padding as it reshapes the result; this accounts for a lot of the "1
everywhere (you can interpret v"1
as "force the verb v
to operate on rank 1 subarrays of the argument").
data_file_name =: '2.data'
data =: > 0 ". each cutopen toJ fread data_file_name
NB. {. take, i. index of; this removes trailing zeros
remove_padding =: {.~ i.&0
NB. }. behead, }: curtail; this computes successive differences
diff =: }. - }:
NB. a b in_range y == a <: y <: b
in_range =: 4 : '(((0 { x) & <:) * (<: & (1 { x))) y'
NB. a row is safe if either all successive differences are in [1..3] or all in [_3.._1]
NB. +. or
ranges =: 2 2 $ 1 3 _3 _1
row_safe =: (+./"1) @: (*/"1) @: (ranges & (in_range"1 _)) @: diff @: remove_padding
result1 =: +/ safe"1 data
NB. x delete y is y without the xth element
delete =: 4 : '(x {. y) , ((>: x) }. y)'"0 _
modified_row =: 3 : 'y , (i.#y) delete y'
modified_row_safe =: 3 : '+./"1 row_safe"1 modified_row"1 y'
result2 =: +/ modified_row_safe data
Rust
The function is_sorted_by on Iterators turned out helpful for compactly finding if a report is safe. In part 2 I simply tried the same with each element removed, since all reports are very short.
fn parse(input: String) -> Vec<Vec<i32>> {
input.lines()
.map(|l| l.split_whitespace().map(|w| w.parse().unwrap()).collect())
.collect()
}
fn is_safe(report: impl DoubleEndedIterator<Item=i32> + Clone) -> bool {
let safety = |a: &i32, b: &i32| (1..=3).contains(&(b - a));
report.clone().is_sorted_by(safety) || report.rev().is_sorted_by(safety)
}
fn part1(input: String) {
let reports = parse(input);
let safe = reports.iter().filter(|r| is_safe(r.iter().copied())).count();
println!("{safe}");
}
fn is_safe2(report: &[i32]) -> bool {
(0..report.len()).any(|i| { // Try with each element removed
is_safe(report.iter().enumerate().filter(|(j, _)| *j != i).map(|(_, n)| *n))
})
}
fn part2(input: String) {
let reports = parse(input);
let safe = reports.iter().filter(|r| is_safe2(r)).count();
println!("{safe}");
}
util::aoc_main!();
is_sorted_by
is new to me, could be very useful.
The is_sorted_by
is a really nice approach. I originally tried using that function thinking that |a, b| a > b
or |a, b| a < b
would cut it but it didn't end up working. I never thought to handle the check for the step being between 1 and 3 in the callback closure for that though.
C
First went through the input in one pass, number by number, but unfortunately that wouldn't fly for part 2.
Code
#include "common.h"
static int
issafe(int *lvs, int n, int skip)
{
int safe=1, asc=0,prev=0, ns=0,i;
for (i=0; safe && i<n; i++) {
if (i == skip)
{ ns = 1; continue; }
if (i-ns > 0)
safe = safe && lvs[i] != prev &&
lvs[i] > prev-4 && lvs[i] < prev+4;
if (i-ns == 1)
asc = lvs[i] > prev;
if (i-ns > 1)
safe = safe && (lvs[i] > prev) == asc;
prev = lvs[i];
}
return safe;
}
int
main(int argc, const char **argv)
{
char buf[64], *rest, *tok;
int p1=0,p2=0, lvs[16],n=0, i;
if (argc > 1)
DISCARD(freopen(argv[1], "r", stdin));
while ((rest = fgets(buf, sizeof(buf), stdin))) {
for (n=0; (tok = strsep(&rest, " ")); n++) {
assert(n < (int)LEN(lvs));
lvs[n] = (int)strtol(tok, NULL, 10);
}
for (i=-1; i<n; i++)
if (issafe(lvs, n, i))
{ p1 += i == -1; p2++; break; }
}
printf("02: %d %d\n", p1, p2);
}
What is this coding style? The function type, name and open brace placement made me think GNU at first, but the code in the body doesn't look like GCS at all.
BSD more or less. Mostly K&R except for function declarations.
Uiua
Uiua is still developing very quickly, and this code uses the experimental tuples
function, hence the initial directive.
# Experimental!
$ 7 6 4 2 1
$ 1 2 7 8 9
$ 9 7 6 2 1
$ 1 3 2 4 5
$ 8 6 4 4 1
$ 1 3 6 7 9
β(βββΈβ @\s)βΈβ @\n # Partition at \n, then at space, parse ints.
IsSorted β +β(βββ.|ββ.) # Compare with sorted array.
IsSmall β /ΓΓβ(>0|<4)β΅βΒ―1-β»1. # Copy offset by 1, check diffs.
IsSafe β ΓβIsSmall IsSorted # Safe if Small steps and Ordered.
IsSafer β Β±/+β‘IsSafe β§
<-1⧻. # Choose 4 from 5, check again.
&p/+β‘IsSafe . # Part1 : Is each row safe?
&p/+β‘(Β±+βIsSafe IsSafer) # Part2 : Is it safe or safer?
This looks so alien! Does it work with the full set? The comment says 5, choose 4, but I guess itβs written as n, choose n-1?
How do you write this, not conceptually but physically. Do you have a char picker open at all times?
Haha, you can do it that way, in fact the online Uiua Pad editor has all the operators listed along the top.
But all the operators have ascii names, so you can type e.g.
IsSmall = reduce mul mul fork(>0|<4) abs drop neg 1 - rot 1 dup
and the formatter will reduce that to
IsSmall β /ΓΓβ(>0|<4)β΅βΒ―1-β»1.
whenever you save or execute code.
That works in the Pad, and you can enable similar functionality in other editors.
i can only imagine doing it with a drawing tablet
I like to assume people using array programming languages just have a crystal ball that they use to call upon magic runes on the screen
Of course I ended up with a off-by-one error for the second part, so things took a bit longer than they really should've.
But either way, behold, messy C#:
C#
int[][] reports = new int[0][];
public void Input(IEnumerable<string> lines)
{
reports = lines.Select(l => l.Split(' ').Select(p => int.Parse(p)).ToArray()).ToArray();
}
public void Part1()
{
int safeCount = reports.Where(report => CheckReport(report)).Count();
Console.WriteLine($"Safe: {safeCount}");
}
public void Part2()
{
int safeCount = reports.Where(report => {
if (CheckReport(report))
return true;
for (int i = 0; i < report.Length; ++i)
if (CheckReport(report.Where((_, j) => j != i)))
return true;
return false;
}).Count();
Console.WriteLine($"Safe: {safeCount}");
}
bool CheckReport(IEnumerable<int> report)
{
var diffs = report.SkipLast(1).Zip(report.Skip(1)).Select(v => v.Second - v.First);
return diffs.All(v => Math.Abs(v) <= 3) && (diffs.All(v => v > 0) || diffs.All(v => v < 0));
}
Nim
Got correct answer for part 1 on first try, but website rejected it. Wasted some time debugging and trying different methods. Only to have the same answer accepted minutes later. =(
proc isSafe(report: seq[int]): bool =
let diffs = collect:
for i, n in report.toOpenArray(1, report.high): n - report[i]
(diffs.allIt(it > 0) or diffs.allIt(it < 0)) and diffs.allIt(it.abs in 1..3)
proc solve(input: string): AOCSolution[int, int] =
let lines = input.splitLines()
var reports: seq[seq[int]]
for line in lines:
reports.add line.split(' ').map(parseInt)
for report in reports:
if report.isSafe():
inc result.part1
inc result.part2
else:
for t in 0..report.high:
var mReport = report
mReport.delete t
if mReport.isSafe():
inc result.part2
break
Haskell
This was quite fun! I got a bit distracted trying to rewrite safe
in point-free style, but I think this version is the most readable. There's probably a more monadic way of writing lessOne
as well, but I can't immediately see it.
safe xs = any gradual [diffs, negate <$> diffs]
where
diffs = zipWith (-) (drop 1 xs) xs
gradual = all (`elem` [1 .. 3])
lessOne [] = []
lessOne (x : xs) = xs : map (x :) (lessOne xs)
main = do
input :: [[Int]] <- map (map read . words) . lines <$> readFile "input02"
print . length $ filter safe input
print . length $ filter (any safe . lessOne) input
Love to see your haskell solutions!
I am so far very amazed with the compactness of your solutions, your lessOne
is very much mind-Bending.
I have never used or seen <$>
before, is it a monadic $
?
Also I can't seem to find your logic for this safety condition: The levels are either all increasing or all decreasing
, did you figure that it wasn't necessary?
<$>
is just fmap
as an infix operator.
>>> fmap (+1) [1,2,3]
[2,3,4]
>>> (+1) <\$> [1,2,3]
[2,3,4]
For the last point, it isn't needed since the differences between elements should be all positive or all negative for the report to be safe. This is tested with the combination of negate
and gradual
.
I am also enjoying these Haskell solutions. I'm still learning the language, so it's been cool to compare my solution with these and grow my understanding of Haskell.
Haskell
runningDifference :: [Int] -> [Int]
runningDifference (a:[]) = []
runningDifference (a:b:cs) = a - b : (runningDifference (b:cs))
isSafe :: [Int] -> Bool
isSafe ds = (all (> 0) ds || all (< 0) ds) && (all (flip elem [1, 2, 3] . abs) ds)
isSafe2 :: [Int] -> Bool
isSafe2 ds = any (isSafe2') (zip [0..length ds] (cycle [ds]))
isSafe2' (i, ls) = isSafe . runningDifference $ list
where
list = dropIndex i ls
dropIndex _ [] = []
dropIndex 0 (a:as) = dropIndex (-1) as
dropIndex i (a:as) = a : dropIndex (i - 1) as
main = do
c <- getContents
let reports = init . lines $ c
let levels = map (map read . words) reports :: [[Int]]
let differences = map runningDifference levels
let safety = map isSafe differences
let safety2 = map isSafe2 levels
putStrLn . show . length . filter (id) $ safety
putStrLn . show . length . filter (id) $ safety2
return ()
Took me way too long to figure out that I didn't have to drop one of them differences but the initial Number